;;; Autor: Jose Ignacio Aguillo Mendi
;;; E-mail: pantic@infonegocio.com
;;; E-mail2: 452446@cepsz.unizar.es
;;; Fichero: ejemplos.lsp
;;; Contenido: Ejemplos de utilizacion del sistema experto basado en reglas con encadenamiento progresivo
;;; Fecha de ultima modificacion: 20-01-2002
;;; Comentarios: Puede que sea necesario cambiar el path a los ficheros en las funciones compile-file y load

(compile-file "e:/ierl 2.1/ierl Forward Chaining.lsp")
(compile-file "e:/ierl 2.1/ierl Pattern Matching.lsp")
(compile-file "e:/ierl 2.1/ierl Rule Definition.lsp")
(compile-file "e:/ierl 2.1/ierl Streams.lsp")
(compile-file "e:/ierl 2.1/ierl21.lsp")
(load "e:/ierl 2.1/ierl Forward Chaining.fasl")
(load "e:/ierl 2.1/ierl Pattern Matching.fasl")
(load "e:/ierl 2.1/ierl Rule Definition.fasl")
(load "e:/ierl 2.1/ierl Streams.fasl")
(load "e:/ierl 2.1/ierl21.fasl")

(defun ejemplo-1 ()
	(clear)
	(recuerda-afirmacion '(bozo es un perro))
	(recuerda-afirmacion '(deedee es un caballo))
	(recuerda-afirmacion '(deedee es padre de sugar))
	(recuerda-afirmacion '(deedee es padre de brassy))
	(recuerda-regla '(misma-especie
		((? padre) es un (? especie))
		((? padre) es padre de (? cria))
                   (progn (assert! '((? cria) es un (? especie)))
                     (format t "~%~a es ~a" '(? cria) '(? especie))))))

(defun ejemplo-2 ()
	(clear)
	(recuerda-afirmacion '(bobby es un perro))
	(recuerda-afirmacion '(deedee es un caballo))
	(recuerda-afirmacion '(deedee es padre de brassy))
  (recuerda-afirmacion '(deedee es padre de sugar))
  (recuerda-afirmacion '(bobby es padre de sussie))
  (recuerda-afirmacion '(bobby es padre de jimmy))


	(recuerda-regla '(misma-especie
		((? padre) es un (? especie))
		((? padre) es padre de (? cria))
                   (progn (assert! '((? cria) es un (? especie)))
                     (format t "~%~a es ~a" '(? cria) '(? especie))))))

(defun ejemplo-3 ()
      (clear)
	(recuerda-afirmacion '(robbie tiene manchas oscuras))
	(recuerda-afirmacion '(robbie tiene color leonado))
	(recuerda-afirmacion '(robbie come carne))
	(recuerda-afirmacion '(robbie tiene pelo))
	(recuerda-afirmacion '(suzie tiene plumas))
	(recuerda-afirmacion '(suzie vuela bien))
	(recuerda-regla '(es-mamifero
		((? animal) tiene pelo)
		(assert! '((? animal) es mamifero))))
	(recuerda-regla '(es-ave
		((? animal) tiene plumas)
		(assert! '((? animal) es ave))))
	(recuerda-regla '(es-carnivoro
		((? animal) come carne)
		(assert! '((? animal) es carnivoro))))
	(recuerda-regla '(es-leopardo
		((? animal) es mamifero)
		((? animal) es carnivoro)
		((? animal) tiene color leonado)
		((? animal) tiene manchas oscuras)						
		(assert! '((? animal) es leopardo))))
	(recuerda-regla '(es-albatros
		((? animal) es ave)
		((? animal) vuela bien)		
		(assert! '((? animal) es albatros)))))

(defun puede-mover? (lista)
  (not (eq (mod (length lista) 3) 2)))

(defun ejemplo-4 () ;;; No fnciona=>prioridades en las reglas
  (clear)
  (recuerda-afirmacion '(estado 2 8 3 1 6 4 7 H 5 camino))
  (recuerda-regla
   '(arriba
     (estado ($ a) (? b) (? c) (? d) H ($ e) camino ($ movimientos))
     (assert! '(estado ($ a) H (? c) (? d) (? b) ($ e) camino ($ movimientos) ^))))
  (recuerda-regla
   '(abajo
     (estado ($ a) H (? b) (? c) (? d) ($ e) camino ($ movimientos))
     (assert! '(estado ($ a) (? d) (? b) (? c) H ($ e) camino ($ movimientos) v))))
  (recuerda-regla
   '(izquierda
     (estado ($ a puede-mover?) (? b) H ($ c) camino ($ movimientos))
     (assert! '(estado ($ a) H (? b) ($ c) camino ($ movimientos) <))))
  (recuerda-regla
   '(derecha
     (estado ($ a) H (? b) ($ c puede-mover?) camino ($ movimientos))
     (assert! '(estado ($ a) (? b) H ($ c) camino ($ movimientos) >))))
  (recuerda-regla
   '(repeticiones-de-nodo
     (estado ($ actual) camino ($ movimientos-1))
     (estado ($ actual) camino ($ movimientos-1) (? x) ($ y))
     (retract! '(estado ($ actual) camino ($ movimientos-1) (? x) ($ y)))))

  (recuerda-regla
   '(reconoce-solucion
     (estado 1 2 3 8 H 4 7 6 5 camino ($ movimientos))
     (progn  
       (retract! '(estado 1 2 3 8 H 4 7 6 5 camino ($ movimientos)))
       (assert! '(solucion ($ movimientos))))))
  (recuerda-regla
   '(escribe-solucion
     (solucion ($ movimientos))
     (progn
       (format t "~&Solucion: ($ movimientos)~%" )
       ))))
(defun ejemplo-5 ()
  (clear)
  (recuerda-afirmacion '(bloque A)) 
  (recuerda-afirmacion '(bloque B))
  (recuerda-afirmacion '(bloque C))
  (recuerda-afirmacion '(bloque D))
  (recuerda-afirmacion '(bloque E))
  (recuerda-afirmacion '(bloque F))
  (recuerda-afirmacion '(estado nada esta-encima-del A))
  (recuerda-afirmacion '(estado A esta-encima-del B))
  (recuerda-afirmacion '(estado B esta-encima-del C))
  (recuerda-afirmacion '(estado C esta-encima-del suelo))
  (recuerda-afirmacion '(estado nada esta-encima-del D))
  (recuerda-afirmacion '(estado D esta-encima-del E))
  (recuerda-afirmacion '(estado E esta-encima-del F))
  (recuerda-afirmacion '(estado F esta-encima-del suelo))
  (recuerda-afirmacion '(objetivo C esta-encima-del E))
  (recuerda-regla 
   '(mover-bloque-sobre-bloque
      (objetivo (? objeto-1) esta-encima-del (? objeto-2))
      (bloque (? objeto-1))
      (bloque (? objeto-2))
      (estado nada esta-encima-del (? objeto-1))
      (estado (? objeto-1) esta-encima-del (? objeto-3))
      (estado nada esta-encima-del (? objeto-2))
     
     (progn
       (retract! '(objetivo (? objeto-1) esta-encima-del (? objeto-2)))
       (retract! '(estado (? objeto-1) esta-encima-del (? objeto-3)))
       (retract! '(estado nada esta-encima-del (? objeto-2)))
       (assert! '(estado (? objeto-1) esta-encima-del (? objeto-2)))
       (assert! '(estado nada esta-encima-del (? objeto-3)))
       (format t "~&~a movido encima del ~a.~%" '(? objeto-1) '(? objeto-2)))))
  (recuerda-regla
   '(mover-bloque-al-suelo
     (objetivo (? objeto-1) esta-encima-del suelo)
     (bloque (? objeto-1))
     (estado nada esta-encima-del (? objeto-1))
     (estado (? objeto-1) esta-encima-del (? objeto-2))
     (progn
      (retract! '(objetivo (? objeto-1) esta-encima-del suelo))
      (retract! '(estado (? objeto-1) esta-encima-del (? objeto-2)))
      (assert! '(estado (? objeto-1) esta-encima-del suelo))
      (assert! '(estado nada esta-encima-del (? objeto-2)))
      (format t "~&~a movido encima del suelo.~%" '(? objeto-1)))))
  (recuerda-regla
   '(libera-bloque-movible
     (objetivo (? objeto-1) esta-encima-del (? _))
     (bloque (? objeto-1))
     (estado (? objeto-2) esta-encima-del (? objeto-1))
     (bloque (? objeto-2))
     (assert! '(objetivo (? objeto-2) esta-encima-del suelo))))
  (recuerda-regla
   '(libera-bloque-soporte
     (objetivo (? _) esta-encima-del (? objeto-1))
     (bloque (? objeto-1))
     (estado (? objeto-2) esta-encima-del (? objeto-1))
     (bloque (? objeto-2))
     (assert! '(objetivo (? objeto-2) esta-encima-del suelo)))))

(defun ejemplo-6 ()
   (clear)
   (recuerda-afirmacion '(pila A B C))
   (recuerda-afirmacion '(pila D E F))
   (recuerda-afirmacion '(objetivo C esta-encima-del E))
   (recuerda-regla
    '(mover-bloque-sobre-bloque
      (objetivo (? bloque-1) esta-encima-del (? bloque-2))
      (pila (? bloque-1) ($ resto-1))
      (pila (? bloque-2) ($ resto-2))
      (progn
       (retract! '(objetivo (? bloque-1) esta-encima-del (? bloque-2)))
       (retract! '(pila (? bloque-1) ($ resto-1)))
       (retract! '(pila (? bloque-2) ($ resto-2)))
       (assert! '(pila ($ resto-1)))
       (assert! '(pila (? bloque-1) (? bloque-2) ($ resto-2)))
       (format t "~&~a movido encima del ~a.~%" '(? bloque-1) '(? bloque-2)))))
   (recuerda-regla
    '(mover-bloque-al-suelo
      (objetivo (? bloque-1) esta-encima-del suelo)
      (pila (? bloque-1) ($ resto))
      (progn
       (retract! '(objetivo (? bloque-1) esta-encima-del suelo))
       (retract! '(pila (? bloque-1) ($ resto)))
       (assert! '(pila (? bloque-1)))
       (assert! '(pila ($ resto)))
       (format t "~&~a movido encima del suelo.~%" '(? bloque-1)))))
   (recuerda-regla
    '(libera-bloque-movible
      (objetivo (? bloque) esta-encima-del (? _))
      (pila (? cima) ($ _) (? bloque) ($ _))
      (assert! '(objetivo (? cima) esta-encima-del suelo))))
   (recuerda-regla
    '(libera-bloque-soporte
      (objetivo (? _) esta-encima-del (? bloque))
      (pila (? cima) ($ _) (? bloque) ($ _))
      (assert! '(objetivo (? cima) esta-encima-del suelo)))))
(defun ejemplo-7 () ;;; como el ejemplo-5, pero probando la extension de ligar hechos a variables
  (clear)
  (recuerda-afirmacion '(bloque A)) 
  (recuerda-afirmacion '(bloque B))
  (recuerda-afirmacion '(bloque C))
  (recuerda-afirmacion '(bloque D))
  (recuerda-afirmacion '(bloque E))
  (recuerda-afirmacion '(bloque F))
  (recuerda-afirmacion '(estado nada esta-encima-del A))
  (recuerda-afirmacion '(estado A esta-encima-del B))
  (recuerda-afirmacion '(estado B esta-encima-del C))
  (recuerda-afirmacion '(estado C esta-encima-del suelo))
  (recuerda-afirmacion '(estado nada esta-encima-del D))
  (recuerda-afirmacion '(estado D esta-encima-del E))
  (recuerda-afirmacion '(estado E esta-encima-del F))
  (recuerda-afirmacion '(estado F esta-encima-del suelo))
  (recuerda-afirmacion '(objetivo C esta-encima-del E))
  (recuerda-regla 
   '(mover-bloque-sobre-bloque
      ((? objetivo)<-(objetivo (? objeto-1) esta-encima-del (? objeto-2)))
      (bloque (? objeto-1))
      (bloque (? objeto-2))
      (estado nada esta-encima-del (? objeto-1))
      ((? pila-1)<-(estado (? objeto-1) esta-encima-del (? objeto-3)))
      ((? pila-2)<-(estado nada esta-encima-del (? objeto-2)))
     
     (progn
       (retract! '(? objetivo))
       (retract! '(? pila-1))
       (retract! '(? pila-2))
       (assert! '(estado (? objeto-1) esta-encima-del (? objeto-2)))
       (assert! '(estado nada esta-encima-del (? objeto-3)))
       (format t "~&~a movido encima del ~a.~%" '(? objeto-1) '(? objeto-2)))))
  (recuerda-regla
   '(mover-bloque-al-suelo
     ((? objetivo)<-(objetivo (? objeto-1) esta-encima-del suelo))
     (bloque (? objeto-1))
     (estado nada esta-encima-del (? objeto-1))
     ((? pila)<-(estado (? objeto-1) esta-encima-del (? objeto-2)))

     (progn
      (retract! '(? objetivo))
      (retract! '(? pila))
      (assert! '(estado (? objeto-1) esta-encima-del suelo))
      (assert! '(estado nada esta-encima-del (? objeto-2)))

      (format t "~&~a movido encima del suelo.~%" '(? objeto-1)))))
  (recuerda-regla
   '(libera-bloque-movible
     (objetivo (? objeto-1) esta-encima-del (? _))
     (bloque (? objeto-1))
     (estado (? objeto-2) esta-encima-del (? objeto-1))
     (bloque (? objeto-2))
     (assert! '(objetivo (? objeto-2) esta-encima-del suelo))))
  (recuerda-regla
   '(libera-bloque-soporte
     (objetivo (? _) esta-encima-del (? objeto-1))
     (bloque (? objeto-1))
     (estado (? objeto-2) esta-encima-del (? objeto-1))
     (bloque (? objeto-2))
     (assert! '(objetivo (? objeto-2) esta-encima-del suelo)))))

(defun ejemplo-8 () ;;; como el ejemplo-6, pero probando la extension de ligar hechos a variables
   (clear)
   (recuerda-afirmacion '(pila A B C))
   (recuerda-afirmacion '(pila D E F))
   (recuerda-afirmacion '(objetivo C esta-encima-del E))
   (recuerda-regla
    '(mover-bloque-sobre-bloque
      ((? objetivo)<-(objetivo (? bloque-1) esta-encima-del (? bloque-2)))
      ((? pila-1)<-(pila (? bloque-1) ($ resto-1)))
      ((? pila-2)<-(pila (? bloque-2) ($ resto-2)))
      (progn
       (retract! '(? objetivo))
       (retract! '(? pila-1))
       (retract! '(? pila-2))
       (assert! '(pila ($ resto-1)))
       (assert! '(pila (? bloque-1) (? bloque-2) ($ resto-2)))
       (format t "~&~a movido encima del ~a.~%" '(? bloque-1) '(? bloque-2)))))
   (recuerda-regla
    '(mover-bloque-al-suelo
      ((? objetivo)<-(objetivo (? bloque-1) esta-encima-del suelo))
      ((? pila)<-(pila (? bloque-1) ($ resto)))
      (progn
       (retract! '(? objetivo))
       (retract! '(? pila))
       (assert! '(pila (? bloque-1)))
       (assert! '(pila ($ resto)))
       (format t "~&~a movido encima del suelo.~%" '(? bloque-1)))))
   (recuerda-regla
    '(libera-bloque-movible
      (objetivo (? bloque) esta-encima-del (? _))
      (pila (? cima) ($ _) (? bloque) ($ _))
      (assert! '(objetivo (? cima) esta-encima-del suelo))))
   (recuerda-regla
    '(libera-bloque-soporte

      (objetivo (? _) esta-encima-del (? bloque))
      (pila (? cima) ($ _) (? bloque) ($ _))
      (assert! '(objetivo (? cima) esta-encima-del suelo)))))
(defun heuristica(lista)
   (do
    ((resultado 0)
     (estado-final '(1 2 3 8 H 4 7 6 5) (rest estado-final))
     (lista lista (rest lista)))
    ((endp lista) resultado)
    (if (not (eq (first estado-final) (first lista)))
       (setf resultado (+ resultado 1)))))
(defun es-la-mejor (numero)
   (do ((flujo-afirmaciones *afirmaciones* (resto-del-flujo flujo-afirmaciones))
        (dev t))
       ((final-del-flujo-p flujo-afirmaciones) dev)
      (let ((hecho (principio-del-flujo flujo-afirmaciones)))
         (if (eq (first hecho) 'estado)
            (if (and (eq (second (member 'clase hecho)) 'abierto)(< (second (member 'heuristica hecho)) numero))
               (setf dev nil))))))
(defun ejemplo-9 () ;;; como el 4, pero con heuristica. No funciona=>prioridades en las reglas
  (clear)
  (recuerda-afirmacion  `(estado 2 8 3 1 6 4 7 H 5 camino heuristica ,(heuristica '(2 8 3 1 6 4 7 H 5)) clase cerrado))
  (recuerda-regla
   '(arriba
     (estado ($ a) (? b) (? c) (? d) H ($ e) camino ($ movimientos) heuristica (? _) clase cerrado)
     (assert! 
       `(estado ($ a) H (? c) (? d) (? b) ($ e) camino ($ movimientos) ^ heuristica 
          ,(heuristica '(($ a) H (? c) (? d) (? b) ($ e))) clase abierto))))
  (recuerda-regla
   '(abajo
     (estado ($ a) H (? b) (? c) (? d) ($ e) camino ($ movimientos) heuristica (? _) clase cerrado)
     (assert! 
       `(estado ($ a) (? d) (? b) (? c) H ($ e) camino ($ movimientos) v heuristica
          ,(heuristica '(($ a) (? d) (? b) (? c) H ($ e))) clase abierto))))
  (recuerda-regla
   '(izquierda
     (estado ($ a puede-mover?) (? b) H ($ c) camino ($ movimientos) heuristica (? _) clase cerrado)
     (assert! 
       `(estado ($ a) H (? b) ($ c) camino ($ movimientos) < heuristica
          ,(heuristica '(($ a) H (? b) ($ c))) clase abierto))))
  (recuerda-regla
   '(derecha
     (estado ($ a) H (? b) ($ c puede-mover?) camino ($ movimientos) heuristica (? _) clase cerrado)
     (assert! 
       `(estado ($ a) (? b) H ($ c) camino ($ movimientos) > heuristica
          ,(heuristica '(($ a) (? b) H ($ c))) clase abierto))))
  (recuerda-regla
   '(repeticiones-de-nodo
     (estado ($ actual) camino ($ movimientos-1) heuristica ($ _))
     (estado ($ actual) camino ($ movimientos-1) heuristica ($ _))
     (estado ($ actual) camino ($ movimientos-1) heuristica ($ _))
     ((? nodo)<-(estado ($ actual) camino ($ movimientos-1) (? _) ($ _) heuristica ($ _)))
     (retract! '(? nodo))))
   (recuerda-regla
    '(pasa-el-mejor-a-cerrado
      ((? nodo)<-(($ ppio) heuristica (? h1 es-la-mejor) clase abierto))
      (($ ppio) heuristica (? h1) clase abierto)
      (($ ppio) heuristica (? h1) clase abierto)
      (progn
       (retract! '(? nodo))
       (assert! '(($ ppio) heuristica (? h1) clase cerrado)))))
  (recuerda-regla
   '(reconoce-solucion
     (estado 1 2 3 8 H 4 7 6 5 camino ($ movimientos))
     (progn  
       (retract! '(estado 1 2 3 8 H 4 7 6 5 camino ($ movimientos)))
       (assert! '(solucion ($ movimientos))))))
  (recuerda-regla
   '(escribe-solucion
     (solucion ($ movimientos))
     (progn
       (format t "~&Solucion: ($ movimientos)~%" )
       ))))





